if(!window.console){ window.console = function(){}; }

window.onload = function()
{
   showTopic(0);
}

function showTopic(theTopicNum)
{
   var allTocTopics = document.getElementsByClassName("toc_topic");
   var tocTopicNumId = "toc_topic_" + theTopicNum;

   var allTopics = document.getElementsByClassName("topic");
   var topicNumId = "topic_" + theTopicNum;

   var allSubtopics = document.getElementsByClassName("subtopic");
   var allArrows = document.getElementsByClassName("arrow");

   var i;

   for (i=0; i<allArrows.length; i++)
   {
      removeClassFromElement(allArrows[i], "viewing");
   }

   // Update "viewing" class for all subtopics

   for (i=0; i<allSubtopics.length; i++)
   {
      removeClassFromElement(allSubtopics[i], "viewing");
   }

   // Update "viewing" class for all toc_topics

   for (i=0; i<allTocTopics.length; i++)
   {
      removeClassFromElement(allTocTopics[i], "viewing");
      if (allTocTopics[i].id == tocTopicNumId) addClassToElement(allTocTopics[i], "viewing");
   }

   // Update "hidden" class for all topics

   for (i=0; i<allTopics.length; i++)
   {
      removeClassFromElement(allTopics[i], "hidden");
      if (allTopics[i].id != topicNumId) addClassToElement(allTopics[i], "hidden");
   }
}

function toggleSubtopic(theSubtopicNum)
{
   var subtopicNumId = "subtopic_" + theSubtopicNum;
   var subtopic = document.getElementById(subtopicNumId);

   var showhideNumId = "showhide_" + theSubtopicNum;
   var showhide = document.getElementById(showhideNumId);

   if (subtopic == null)
   {
      console.warn("toggleSubtopic: subtopic null");
   }
   else
   {
      if (elementHasClass(subtopic, "viewing")) hideSubtopic(subtopic, showhide);
      else showSubtopic(subtopic, showhide);
   }
}

function showSubtopic(subtopic, showhide)
{
   addClassToElement(subtopic, "viewing");
   addClassToElement(showhide, "viewing");
}

function hideSubtopic(subtopic, showhide)
{
   removeClassFromElement(subtopic, "viewing");
   removeClassFromElement(showhide, "viewing");
}

/*****************/
//
// Based on code found at:
//
//     <http://stackoverflow.com/questions/195951/change-an-elements-css-class-with-javascript>
//
/****************/

function removeClassFromElementId(theElementId, theClass)
{
   var theElement = document.getElementById(theElementId);

   if (theElement == null)
   {
      console.warn("removeClassFromElementId: could not get element for id " + theElementId);
      return;
   }

   removeClassFromElement(theElement, theClass);
}

function removeClassFromElement(theElement, theClass)
{
   var regex = new RegExp("(?:^|\\s)" + theClass + "(?!\\S)", "g");
   theElement.className = theElement.className.replace(regex,'');
}

function addClassToElementId(theElementId, theClass)
{
   var theElement = document.getElementById(theElementId);

   if (theElement == null)
   {
      console.warn("addClassToElementId: could not get element for id " + theElementId);
      return;
   }

   addClassToElement(theElement, theClass);
}

function addClassToElement(theElement, theClass)
{
   if (!elementHasClass(theElement, theClass))
   {
      theElement.className += " " + theClass;
   }
}

function elementIdHasClass(theElementId, theClass)
{
   var theElement = document.getElementById(theElementId);

   if (theElement == null)
   {
      console.warn("elementIdHasClass: could not get element for id " + theElementId);
      return false; // ???
   }

   return elementHasClass(theElement, theClass);
}

function elementHasClass(theElement, theClass)
{
   var regex = new RegExp("(?:^|\\s)" + theClass + "(?!\\S)");
   return theElement.className.match(regex);
}
